#ifndef RAWSUMMARYDROPPEDMICROBLOCK_H
#define RAWSUMMARYDROPPEDMICROBLOCK_H

#include "DAQDataFormats/RawSummaryDroppedMicroblockV0.h"
#include "DAQDataFormats/Macros.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDroppedMicroblock
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydroppedmicroblock
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {
        static const version_t RAWSUMMARYDROPPEDMICROBLOCK_LATEST_VERSION = LAST_CLASS_VERSION;
    }

    class RawSummaryDroppedMicroblock: public PREVIOUS_VERSION_CLASS_NAME {
        public:
      
            /// Constructors
            RawSummaryDroppedMicroblock (const version_t version = summarydroppedmicroblock::RAWSUMMARYDROPPEDMICROBLOCK_LATEST_VERSION);                             //! The default constructor
            RawSummaryDroppedMicroblock (const RawSummaryDroppedMicroblock& copy_in); //! Deep copy constructor
            RawSummaryDroppedMicroblock (const void* summarydroppedmicroblock_buffer, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION); //! Shallow copy constructor
            /// Destructor
            ~RawSummaryDroppedMicroblock();

            IMPLEMENT_MAIN_STANDARD

            IMPLEMENT_GET_MAIN        (Version       , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeStampLow  , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeStampHigh , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeWindow_sec, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeWindow_usec, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(NumDroppedMicroblocks, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeStamp, uint64_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeWindowTvUsec, suseconds_t)
            IMPLEMENT_GET_AND_SET_MAIN(TimeWindowTvSec, time_t)
	    IMPLEMENT_GET_AND_SET_MAIN(TimeWindowTv, timeval)

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(CURRENT_CLASS)

        protected:
            IMPLEMENT_SET_MAIN        (Version, uint32_t)
            bool                      setFunctionPointers();

    };
 
  
} // END NAMESPACE daqdataformats

#endif /* RAWSUMMARYDROPPEDMICROBLOCK_H */
