#ifndef _DBUTILS_DAQAPPMGR_CONFIGUREDHOSTS_H
#define _DBUTILS_DAQAPPMGR_CONFIGUREDHOSTS_H

#include <DatabaseUtils/DAQAppMgr/Host.h>
#include <boost/shared_ptr.hpp>
#include <string>
#include <vector>

namespace dbutils {
namespace daqappmgr {

/**
 * Container class for the full set of hosts that are used in the DAQ system.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2012/05/30 14:27:44 $
 */

class ConfiguredHosts {

 public:

    // ********************
    // *** Constructors ***
    // ********************

    ConfiguredHosts(const std::string& detectorName,
                    int partitionNumber = 0,
                    const bool& useDBData = false);

    // *****************
    // *** Accessors ***
    // *****************

    bool hasValidData() const {return _hasValidData;}

    boost::shared_ptr<Host> getHostByName(const std::string& hostName) const;

    // temporary modifier

    void _addHost(boost::shared_ptr<Host> host);

 private:

    //bool _fetchTypeData(const std::string& tableDefinitionFilename,
    //                    const std::string& detectorName);

    bool _hasValidData;

    std::vector<boost::shared_ptr<Host> > _hostList;
};

};  // end of namespace daqappmgr
};  // end of namespace dbutils

#endif
