#ifndef _NOVADAQ_LOCATIONUTILS_H
#define _NOVADAQ_LOCATIONUTILS_H

#include <string>
#include <vector>

namespace novadaq {

/**
 * Utility functions for working with the locations of resources.
 *
 * @author Kurt Biery
 * @version $Revision: 1.5 $ $Date: 2014/06/25 04:23:41 $
 */

class LocationUtils {

 public:

    static const std::string SRT_PROTOCOL_PREFIX;
    static const std::string FILE_PROTOCOL_PREFIX;
    static const std::string HTTP_PROTOCOL_PREFIX;
    static const std::string FTP_PROTOCOL_PREFIX;
    static const std::string XML_PROTOCOL_PREFIX;

    static std::string translateURL(const std::string& sourceURL);

    static std::string replaceEnvVars(const std::string& sourceString);

    static std::string wordExpansion(const std::string& sourceString);

    static bool findFile(const std::string& filePath,
                         std::string& locationOfFoundInstance);

    static bool findFile(const std::string& filePath,
                         std::string& locationOfFoundInstance,
                         const std::vector<std::string>& suggestedPrefixes);

 private:

    static bool _findFile(const std::string& filePath,
                          std::string& locationOfFoundInstance);

};

};  // end of namespace novadaq

#endif
