#include "DAQDataFormats/RawConfigurationSystemID.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationSystemID
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfsysid
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats{

//------------------------------------------------------------------------------
// Default constructor
RawConfigurationSystemID::RawConfigurationSystemID(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    reserveInternalBuffer(getPredefinedSize());
    defaultConstructorFloatingSize();
}
//------------------------------------------------------------------------------
RawConfigurationSystemID::RawConfigurationSystemID(const RawConfigurationSystemID& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    copy(copy_in);
}

//------------------------------------------------------------------------------
RawConfigurationSystemID::RawConfigurationSystemID(const void* buffer, const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    copy(buffer);
}

//------------------------------------------------------------------------------
// Destructor
RawConfigurationSystemID::~RawConfigurationSystemID() { }

/// All binding routines
#define STANDARD_ROUTINES                                                                        \
            BIND_GET_AND_SET    (Version       , version0, uint32_t);                            \
            BIND_GET_AND_SET    (DAQSystemID   , version0, uint32_t);                            \
            BIND_GET_AND_SET    (DAQSubSystemID, version0, uint32_t);                            \
            BIND_GET            (HeaderSize    , version0, uint32_t);                            \
            BIND_CUSTOM_FUNCTION(getVersionName, version0, const, uint32_t,       std::string&); \
            BIND_CUSTOM_FUNCTION(setVersionName, version0,      , uint32_t, const std::string&); \
            BIND_STADARD_FUNCTIONS                                                               \
            CURRENT_VERSION_NAMESPACE::CURRENT_CLASS::setConfigurationNameVersion();

#include "DAQDataFormats/setFunctionPointers_template.inc"


}// end of namespaces