#include <fstream>
#include <sstream>
#include <sys/stat.h>
#include <cstdlib>
#include <cctype>

#include <NovaDatabase/Row.h>

using namespace nova::database;
using namespace std;

//************************************************************

Row::Row(const vector<Column>& col, const dBRow_t& row) : 
  dBRow_t(row), fInDB(false), fNModified(0)
{
  for (unsigned int i=0; i<col.size(); ++i) {
    fCol.push_back(Column(col[i]));
  }

  for (unsigned int i=0; i<this->getDBColCount(); ++i) {
    this->Set(string(this->getDBCol(i).getName()),
	      string(this->getDBCol(i).getValue()));
  }
  
}

//************************************************************

Row::Row(const vector<Column>& col) : fInDB(false), fNModified(0)
{
  for (unsigned int i=0; i<col.size(); ++i) {
    fCol.push_back(Column(col[i]));
  }
}

//************************************************************

Row::~Row()
{

}

//************************************************************
Column* Row::Col(std::string name)
{
  unsigned int i=0;
  for (; i<name.length(); ++i)
    name[i] = tolower(name[i]);

  i=0;
  for (; i<fCol.size(); ++i) {
    if (fCol[i].Name() == name)
      return &fCol[i];
  }

  return 0;
}

//************************************************************
void Row::Clear()
{
  for (unsigned int i=0; i<fCol.size(); ++i) 
    fCol[i].Clear();

}


